;============================================================
;Real-time code for Matrix Tres on ActBite
;============================================================
;radius=sqrt(Xdiff^2 + Ydiff^2 + Zdiff^2)

MXTBite:
	push ecx
	push esi
	push ebx
	mov edx,[CAnimal_BUF]
	test edx,edx
	     jz NoMXTOnBiteSimCall
	mov ebx,[CAnimal_BUF_SIZE]
	test ebx,ebx
	     jz NoMXTOnBiteSimCall
	add ebx,edx

	FindDinoForActBiteInstanceLoop:
	mov esi,[edx]
	mov eax,[esi+0DCh]		;instance's main AI sub-class
	cmp ecx,[eax+18h]		;instance's ActBite sub-class
	    jz END_FindDinoForActBiteInstanceLoop
	add edx,4
	cmp edx,ebx
	    jb FindDinoForActBiteInstanceLoop
	    jmp NoMXTOnBiteSimCall

	END_FindDinoForActBiteInstanceLoop:

	mov eax,[PLAYER_OBJ_INVUL_ADDR]
	mov edx,[eax]		;player object

	fld DWORD [esi+30h]	;dino's X position
	fsub DWORD [edx+30h]	;player's X pos
	fmul st0,st0		;Xdiff^2

	fld DWORD [esi+34h]	;dino's Y position
	fsub DWORD [edx+34h]	;player's Y pos
	fmul st0,st0		;Ydiff^2

	fld DWORD [esi+38h]	;dino's Z position
	fsub DWORD [edx+38h]	;player's Z pos
	fmul st0,st0		;Zdiff^2
	fadd st0,st1		;Zdiff^2+Ydiff^2
	fadd st0,st2		;Zdiff^2+Ydiff^2+Xdiff^2

	fsqrt			;sqrt(Xdiff^2 + Ydiff^2 + Zdiff^2)
	fcomp [UseMXTRadius]
	fstsw ax
	fstp st0
	fstp st0

	test ax,0100010100000000b
	     jz NoMXTOnBiteSimCall

	mov ecx,AT100SimulatedObject
	call AT100MAIN

NoMXTOnBiteSimCall:
	pop ebx
	pop esi
	pop ecx

	pop eax 	;get return address
	sub esp,138h	;replaced code
	jmp eax 	;back to normal biting code

